"""Class defining the fonts"""

# pylint: disable=line-too-long

class Font:
    """"Class defining the fonts"""

    FONT_PICO_8 = {
        '0': [1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 3],
        '1': [1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 3],
        '2': [1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 3], 
        '3': [1, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 3],
        '4': [1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1, 3], 
        '5': [1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 3],
        '6': [1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 3], 
        '7': [1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 3],
        '8': [1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 3], 
        '9': [1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1, 3],
        ' ': [0, 0, 0, 3],
        'a': [0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 3], 
        'b': [0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1, 1, 1, 1, 3],
        'c': [0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 1, 1, 3], 
        'd': [0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 1, 3],
        'e': [0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 3], 
        'f': [0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 3],
        'g': [0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 1, 1, 1, 1, 3], 
        'h': [0, 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 3],
        'i': [0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 1, 3], 
        'j': [0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 3],
        'k': [0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 3], 
        'l': [0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 3],
        'm': [0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 3], 
        'n': [0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 3],
        'o': [0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 3], 
        'p': [0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 3],
        'q': [0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 1, 3], 
        'r': [0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1, 3],
        's': [0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 3], 
        't': [0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 3],
        'u': [0, 0, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1, 1, 3], 
        'v': [0, 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 1, 3],
        'w': [0, 0, 0, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 3], 
        'x': [0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 3],
        'y': [0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 3], 
        'z': [0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1, 3],
        'A': [1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 3], 
        'B': [1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 3],
        'C': [0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 3], 
        'D': [1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 3],
        'E': [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 3], 
        'F': [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 3],
        'G': [0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 3], 
        'H': [1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 3],
        'I': [1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 1, 3], 
        'J': [1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 3],
        'K': [1, 0, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 3], 
        'L': [1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 3],
        'M': [1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 3], 
        'N': [1, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 3],
        'O': [0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 3], 
        'P': [1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 3],
        'Q': [0, 1, 0, 1, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 3], 
        'R': [1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 3],
        'S': [0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 3], 
        'T': [1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 3],
        'U': [1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1, 1, 3], 
        'V': [1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 1, 3],
        'W': [1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 5], 
        'X': [1, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1, 3],
        'Y': [1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 3], 
        'Z': [1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 1, 1, 3],
        '!': [0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 3], 
        "'": [0, 1, 0, 1, 3],
        '(': [0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 3], 
        ')': [0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 3],
        '+': [0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 3], 
        ',': [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 3],
        '-': [0, 0, 0, 0, 0, 0, 1, 1, 1, 3], 
        '<': [0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 3],
        '=': [0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 3], 
        '>': [1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 3],
        '?': [1, 1, 1, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 3], 
        '[': [1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 3],
        ']': [0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 1, 3], 
        '^': [0, 1, 0, 1, 0, 1, 3],
        '_': [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 3], 
        ':': [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 3],
        ';': [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 3], 
        '.': [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3],
        '/': [0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 3], 
        '{': [0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0, 0, 1, 1, 3],
        '|': [0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 3], 
        '}': [1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 3],
        '~': [0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 3], 
        '$': [1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 1, 3],
        '@': [0, 1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 3], 
        '%': [1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 3]
    }

    FONT_GICKO = {
        '0': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 6],
        '1': [0, 1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 4],
        '2': [0, 1, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 6],
        '3': [1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 6],
        '4': [0, 1, 1, 1, 1, 0,
            1, 1, 0, 1, 1, 0,
            1, 0, 0, 1, 1, 0,
            1, 0, 0, 1, 1, 0,
            1, 1, 1, 1, 1, 1,
            0, 0, 0, 1, 1, 0, 6],
        '5': [1, 1, 1, 1, 1, 0,
            1, 0, 0, 0, 0, 0,
            1, 1, 1, 1, 1, 0,
            0, 0, 0, 1, 1, 1,
            1, 0, 0, 1, 1, 1,
            0, 1, 1, 1, 1, 0, 6],
        '6': [0, 1, 1, 1, 1, 0,
            1, 1, 0, 0, 0, 0,
            1, 1, 1, 1, 1, 0,
            1, 1, 0, 0, 1, 1,
            1, 1, 0, 0, 1, 1,
            0, 1, 1, 1, 1, 0, 6],
        '7': [1, 1, 1, 1, 1, 1,
            0, 0, 0, 0, 1, 1,
            0, 0, 0, 1, 1, 0,
            0, 0, 1, 1, 0, 0,
            0, 1, 1, 1, 0, 0,
            0, 1, 1, 1, 0, 0, 6],
        '8': [0, 1, 1, 1, 1, 0,
            1, 0, 0, 1, 1, 1,
            0, 1, 1, 1, 1, 0,
            1, 0, 0, 1, 1, 1,
            1, 0, 0, 1, 1, 1,
            0, 1, 1, 1, 1, 0, 6],
        '9': [0, 1, 1, 1, 1, 0,
            1, 0, 0, 1, 1, 1,
            1, 0, 0, 1, 1, 1,
            0, 1, 1, 1, 1, 1,
            0, 0, 0, 1, 1, 1,
            0, 1, 1, 1, 1, 0, 6],
        ' ': [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2],
        'A': [0, 1, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 6],
        'B': [1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 6],
        'C': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 6],
        'D': [1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 6],
        'E': [1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 5],
        'F': [1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 5],
        'G': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 6],
        'H': [1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 5],
        'I': [1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 4],
        'J': [0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 6],
        'K': [1, 1, 0, 0, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 1, 1, 6],
        'L': [1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 1, 1, 4],
        'M': [1, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 6],
        'N': [1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 6],
        'O': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 6],
        'P': [1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 6],
        'Q': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0, 1, 6],
        'R': [1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 6],
        'S': [0, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 6],
        'T': [1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 6],
        'U': [1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 6],
        'V': [1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 6],
        'W': [1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 6],
        'X': [1, 0, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 6],
        'Y': [1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 6],
        'Z': [1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 6],
        ':': [0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 2],
        '?': [0, 1, 1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 6],
        '!': [1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 2],
        '.': [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2],
        '-': [0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 3]
    }


    @staticmethod
    def retrieve_glyph(character, font=None):
        """Function to retrieve the glyph of a character from a font"""

        # use default font if none is given
        if font is None:
            font = Font.FONT_PICO_8

        if character in font:
            return font[character]

        # unknown characters are returned as spaces
        return font[' ']


    @staticmethod
    def supported_characters(font=None):
        """Function to return the characters of the font"""
        # use default font if none is given
        if font is None:
            font = Font.FONT_PICO_8

        return font.keys()


__all__ = ["Font"]
